// Excel_TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Excel_Test.h"
#include "Excel_TestDlg.h"

#include "excel8.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExcel_TestDlg dialog

CExcel_TestDlg::CExcel_TestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExcel_TestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExcel_TestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExcel_TestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExcel_TestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExcel_TestDlg, CDialog)
	//{{AFX_MSG_MAP(CExcel_TestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExcel_TestDlg message handlers

BOOL CExcel_TestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CExcel_TestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExcel_TestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CExcel_TestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CExcel_TestDlg::OnButton1() 
{
    // Excel Objekte
    _Application    m_app;
	Workbooks       m_workbooks;   
	_Workbook       m_workbook;
	Worksheets      m_worksheets;
	_Worksheet      m_worksheet;
	Range           m_range;

    
    CString         ExcelFileName   = "D:\\Excel_Test\\ExcelFile.xls";  
    CString         ExcelSheetName  = "Tabelle1";
    

    // OLE initialiseren!!! Sonst geht es nicht
    AfxOleInit();    
    // OLE initialiseren!!! Sonst geht es nicht


	COleVariant covOptional((long)DISP_E_PARAMNOTFOUND, VT_ERROR);
	COleVariant covTrue((short)TRUE);
	COleVariant covFalse((short)FALSE);

	// Excel Instanz erzeugen
    m_app.CreateDispatch( _T("Excel.Application") );
	
    // Die Workbook Collection
    m_workbooks = m_app.GetWorkbooks();

	//Applikation sichtbar machen, wenn du das willst
	//m_app.SetVisible(TRUE);

	//Das gewnschte Workbook(=Exceldatei) ffnen.
	m_workbook = m_workbooks.Open(  ExcelFileName, 
                                    covOptional, 
                                    covTrue, 
                                    covOptional, 
                                    covOptional, 
                                    covOptional, 
                                    covOptional, 
                                    covOptional, 
                                    covOptional, 
                                    covOptional, 
                                    covOptional, 
                                    covOptional, 
                                    covOptional);

	// Die Worksheet Collection des Workbooks
    m_worksheets = m_workbook.GetWorksheets();


	// Das gesuchte Worksheet (=Tabellenblatt) ermitteln
    for ( int i=1;i<m_worksheets.GetCount()+1;i++ )
	{
		m_worksheet = m_worksheets.GetItem( COleVariant( (short)i ));
		if( m_worksheet.GetName() == ExcelSheetName )
		{
			break;
		}
	}

    //Jetzt die gewnschte Zelle als Bereich auswhlen
    CString strRange = "A1:A1";
	m_range = m_worksheet.GetRange(COleVariant( strRange) );

	// Inhalt der Zelle lesen
    COleVariant var = m_range.GetValue();

    // Man kann auch z.B. eine ganze Zeile als Bereich markieren und die Werte aller
    // Zellen der Spalte in einem Array empfangen


    // Aufrumen
	m_workbook.Close(COleVariant((short)FALSE), covOptional, covOptional);
	m_app.Quit();
	m_app.ReleaseDispatch();
    
    AfxOleTerm();
}
